{$A-,B-,D+,E-,F-,G-,I-,L+,N-,O-,R-,S-,V-,X+}
{۲}
{              Digital music input/output routines.                ۲}
{             Developed in 1992 by FRIENDS software                ۲}
{                     Freely for spreading                         ۲}
{ Version      : 1.0                                               ۲}
{ Last release : 11/06/92                                          ۲}
{۲}

Unit SongIO;

Interface
Uses Dos,LZHSTM;
type
   PattType      = array[0..1023] of byte;
   STMHeaderType = record
                    SongName     : array[0..19] of Char;
                    EdName       : array[0..7]  of Char;
                    EOF          : Byte;
                    FileType     : Byte;
                    Version      : Word;
                    Temp         : Byte;
                    NumPatterns  : Byte;
                    GlobalVolume : Byte;
                    VoiceRepart  : Byte;
                    Reserved     : array[0..11] of Char;
                   end;
   STMInstrDescr = record
                    Name         : array[0..11] of Char;
                    Unused1      : Word;
                    SampleSeg    : Word;
                    Length       : Word;
                    LoopStart    : Word;
                    LoopEnd      : Word;
                    DefVolume    : Byte;
                    Unused2      : Byte;
                    SpeedOfC     : Word;
                    Unused3      : Longint;
                    Unused4      : Word;
                   end;
   CDMHeaderType = record
                    SongName     : array[0..19] of Char;
                    EdName       : array[0..7]  of Char;
                    EOF          : Byte;
                    FileType     : Byte;
                    Temp         : Byte;
                    GlobalVolume : Byte;
                    CompMethod   : Byte;
                    NumPatterns  : Byte;
                    NumSamples   : Byte;
                    VoiceRepart  : Byte;
                    Reserved1    : Byte;
                    Reserved2    : Word;
                    AddInfoSize  : Word;
                   end;
   CDMInstrDescr = record
                    Name         : array[0..11] of Char;
                    Unused1      : array[0..3] of byte;
                    SampleNo     : Byte;
                    UncompLength : Word;
                    LoopStart    : Word;
                    LoopEnd      : Word;
                    DefVolume    : Byte;
                    SpeedOfC     : Word;
                    CompLength   : Word;
                    SampleOfs    : LongInt;
                   end;
const
   TempMultiply  : Word = 26;
   TempDivider   : Word = 8;
   CDMHeader     : CDMHeaderType =
                   (SongName     : '                    ';
                    EdName       : 'CDM file';
                    EOF          : 26;
                    FileType     : 3;
                    Temp         : 0;
                    GlobalVolume : 0;
                    CompMethod   : 0;
                    NumPatterns  : 0;
                    NumSamples   : 0;
                    VoiceRepart  : $1B;
                    Reserved1    : 0;
                    Reserved2    : 0;
                    AddInfoSize  : 0);
   STMHeader     : STMHeaderType =
                   (SongName     : '                    ';
                    EdName       : 'STM file';
                    EOF          : 26;
                    FileType     : 2;
                    Version      : $1502;
                    Temp         : 0;
                    NumPatterns  : 0;
                    GlobalVolume : 0;
                    VoiceRepart  : $1B;
                    Reserved     : 'XXXXXXXXXXXX');

   VoiceRepart   : array[0..3] of word = (0,4,8,12);
{ It contain offsets of channel data in patterns ۲}

type
   DispRes       = Procedure(Num1,Num2 : Word);
var
   Instr,InsOrg  : array[0..30] of Pointer;
   Sizes,LoopStart,LoopEnd,SpeedOfC
                 : array[0..30] of Word;
   DefVolm       : array[0..30] of Byte;
   InitInstr     : array[0..30] of Boolean;
   InstrNm       : array[0..31] of string[12];
   Order         : array[0..127] of byte;
   SongName      : String[20];
   Patt          : array[0..127] of ^PattType;
   Temp          : Word;
   GVolume,NumPatt,RealTemp,
   Error         : Byte;
   DisplayResults: DispRes;

(*۲*)
(*  Used values of Error are:  ۲*)
(*                             ۲*)
(*  0 - All right              ۲*)
(*  1 - File not found         ۲*)
(*  2 - Bad file format        ۲*)
(*  3 - Not enough memory      ۲*)
(*  4 - I/O error              ۲*)
(*  5 - Can't write file       ۲*)
(*۲*)

(*۲*)
(*     Interface procedures    ۲*)
(*۲*)
     Procedure FreeAll;
     Procedure LoadSTM(FName : PathStr);
     Procedure SaveSTM(FName : PathStr);
     Procedure LoadCDM(FName : PathStr);
     Procedure SaveCDM(FName : PathStr);

Implementation

(*۲*)
(*   Free all grabbed memory   ۲*)
(*۲*)
procedure FreeAll;
var i : Byte;
begin
 for i:=0 to 30 do
     if (InitInstr[i]) and (InsOrg[i]<>NIL)
        then FreeMem(InsOrg[i],Sizes[i]+16);
 for i:=1 to NumPatt do
     if Patt[i-1]<>NIL then Dispose(Patt[i-1]);
 FillChar(InitInstr,SizeOf(InitInstr),0);
 FillChar(Patt,SizeOf(Patt),0);
 FillChar(InsOrg,SizeOf(InsOrg),0);
 FillChar(Sizes,SizeOf(Sizes),0);
 FillChar(DefVolm,SizeOf(DefVolm),64);
 FillChar(InstrNm,SizeOf(InstrNm),0);
 FillChar(LoopStart,SizeOf(LoopStart),0);
 FillChar(LoopEnd,SizeOf(LoopEnd),255);
 FillChar(Order,SizeOf(Order),99);
 SongName:='';RealTemp:=$60;
 GVolume:=64;NumPatt:=0;
 asm lea di,SpeedOfC; mov cx,31; mov ax,8448; cld; rep stosw; end;
end;

(*۲*)
(*      Load a .STM module     ۲*)
(*۲*)
procedure LoadSTM;
label LocExit;
var p      : Pointer;
    Tmp    : STMInstrDescr;
    InsSeg : array[0..30] of Word;
    i,j    : Word;
    STMH   : STMHeaderType;
    SNum   : Byte;
begin
 FreeAll;
 Error:=0;InOutRes:=0;
 Assign(WorkFile,FName);Reset(WorkFile,1);
 if IOResult<>0 then begin Error:=1;GoTo LocExit;end;
 BlockRead(WorkFile,STMH,SizeOf(STMHeaderType));
 if IOResult>0 then begin Error:=4;GoTo LocExit;end;
 if STMH.FileType<>2 then begin Error:=2;GoTo LocExit;end;
 Move(STMH.SongName,SongName[1],20);
 i:=1;While (SongName[i]<>#0) and (i<21) do Inc(i);
 SongName[0]:=Char(i-1);
 j:=STMH.VoiceRepart;
 if j<>byte('X') then
    for i:=0 to 3 do
        begin
         VoiceRepart[i xor 3]:=(j and 3) shl 2;
         j:=j shr 2;
        end;
 RealTemp:=STMH.Temp;
 Temp:=RealTemp*TempMultiply div TempDivider;
 GVolume:=STMH.GlobalVolume;
 NumPatt:=STMH.NumPatterns;SNum:=255;
 for i:=0 to 30 do
     begin
      BlockRead(WorkFile,Tmp,SizeOf(STMInstrDescr));
      if IOResult<>0 then begin Error:=4;GoTo LocExit;end;
      Sizes[i]:=Tmp.Length;
      if Sizes[i]>1 then
         begin
          InitInstr[i]:=True;
          Move(Tmp.Name,InstrNm[i][1],12);
          j:=0;While (InstrNm[i][j+1]<>#0) and (j<12) do Inc(j);
          InstrNm[i][0]:=Char(j);
          LoopStart[i]:=Tmp.LoopStart;
          LoopEnd[i]:=Tmp.LoopEnd;
          if (LoopEnd[i]<>$FFFF) and (LoopEnd[i]>Sizes[i])
             then LoopEnd[i]:=Sizes[i];
          DefVolm[i]:=Tmp.DefVolume;
          SpeedOfC[i]:=Tmp.SpeedOfC;
          InsSeg[i]:=Tmp.SampleSeg;
          Inc(SNum);
         end;
     end;
 BlockRead(WorkFile,Order,128);
 if IOResult<>0 then begin Error:=4;GoTo LocExit;end;
 for i:=1 to NumPatt do
     begin
      if @DisplayResults<>NIL then DisplayResults(i,255);
      New(Patt[i-1]);
      if Patt[i-1]=NIL then begin FreeAll;Error:=3;GoTo LocExit; end;
      BlockRead(WorkFile,Patt[i-1]^,1024);
      if IOResult<>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
     end;
 For i:=0 to 30 do
     if InitInstr[i] then
        begin
         if @DisplayResults<>NIL then DisplayResults(i,SNum);
         GetMem(InsOrg[i],Sizes[i]+16);
         p:=InsOrg[i];if p=NIL then begin FreeAll;Error:=3;GoTo LocExit; end;
         if Word(p)>0 then asm  inc word ptr [p+2]; mov word ptr p,0 end;
         Instr[i]:=p;Seek(WorkFile,Longint(InsSeg[i]) shl 4);
         BlockRead(WorkFile,Instr[i]^,Sizes[i]);
         if IOResult<>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
        end;
LocExit:
 Close(WorkFile);InOutRes:=0;
end;

(*۲*)
(*      Save a .STM module     ۲*)
(*۲*)
procedure SaveSTM;
label LocExit;
var p      : Pointer;
    Tmp    : STMInstrDescr;
    InsSeg : array[0..30] of Word;
    STMH   : STMHeaderType;
    i,j,SmpSeg
           : Word;
    SNum   : Byte;
begin
 Error:=0;InOutRes:=0;
 Assign(WorkFile,FName);ReWrite(WorkFile,1);
 if IOResult<>0 then begin Error:=5;GoTo LocExit;end;

 FillChar(SongName[Length(SongName)+1],20-Length(SongName),0);
 Move(SongName[1],STMHeader.SongName,20);
 STMHeader.Temp:=RealTemp;
 STMHeader.GlobalVolume:=GVolume;
 STMHeader.NumPatterns:=NumPatt;

 j:=0;for i:=0 to 3 do j:=(j shl 2) or (VoiceRepart[i] shr 2);
 STMHeader.VoiceRepart:=j;

 BlockWrite(WorkFile,STMHeader,SizeOf(STMHeaderType));
 if IOResult>0 then begin Error:=4;GoTo LocExit;end;

 SmpSeg:=(SizeOf(STMHeaderType)+31*SizeOf(STMInstrDescr)+128+
         +Longint(NumPatt)*1024+15) shr 4;
 SNum:=255;
 for i:=0 to 30 do
     begin
      FillChar(Tmp,SizeOf(Tmp),0);
      if InitInstr[i]
         then begin
               Move(InstrNm[i][1],Tmp.Name,12);
               Tmp.Length:=Sizes[i];
               Tmp.LoopStart:=LoopStart[i];
               Tmp.LoopEnd:=LoopEnd[i];
               Tmp.DefVolume:=DefVolm[i];
               Tmp.SpeedOfC:=SpeedOfC[i];
               Tmp.SampleSeg:=SmpSeg;
               Inc(SmpSeg,(LongInt(Sizes[i])+15) shr 4);
               Inc(SNum);
              end
         else FillChar(Tmp,SizeOf(Tmp),0);
      BlockWrite(WorkFile,Tmp,SizeOf(STMInstrDescr));
      if IOResult<>0 then begin Error:=4;GoTo LocExit;end;
     end;
 BlockWrite(WorkFile,Order,128);
 if IOResult<>0 then begin Error:=4;GoTo LocExit;end;
 for i:=1 to NumPatt do
     begin
      if @DisplayResults<>NIL then DisplayResults(i,255);
      BlockWrite(WorkFile,Patt[i-1]^,1024);
      if IOResult<>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
     end;
 SmpSeg:=30;While not InitInstr[SmpSeg] do Dec(SmpSeg);
 For i:=0 to 30 do
     if InitInstr[i] then
        begin
         if @DisplayResults<>NIL then DisplayResults(i,SNum);
         if i<SmpSeg then j:=(Sizes[i]+15) and $FFF0 else j:=Sizes[i];
         BlockWrite(WorkFile,Instr[i]^,j);
         if IOResult<>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
        end;
LocExit:
 Close(WorkFile);InOutRes:=0;
end;

(*۲*)
(*       Load a .CDM song      ۲*)
(*۲*)
Procedure LoadCDM;
label LocExit;
var i,j,SNum,SNo
             : Integer;
    Smp      : CDMInstrDescr;
    Ordr     : String[128];
    FPos,OldPos
             : LongInt;
    p        : Pointer;
    CDMH     : CDMHeaderType;
    PrevFM   : Byte;
    InsOfs   : array[0..30] of LongInt;
    InsCompL : array[0..30] of Word;
begin
 FreeAll;
 Error:=0;InOutRes:=0;
 PrevFM:=FileMode;FileMode:=0;
 Assign(WorkFile,FName);Reset(WorkFile,1);
 if IOResult>0 then begin Error:=1;GoTo LocExit;end;
 BlockRead(WorkFile,CDMH,SizeOf(CDMHeaderType));
 if IOResult>0 then begin Error:=4;GoTo LocExit;end;
 if CDMH.FileType<>3 then begin Error:=2;GoTo LocExit;end;
 Move(CDMH.SongName,SongName[1],20);
 i:=1;While (SongName[i]<>#0) and (i<21) do Inc(i);
 SongName[0]:=Char(i-1);
 RealTemp:=CDMH.Temp;
 Temp:=RealTemp*TempMultiply div TempDivider;
 j:=CDMH.VoiceRepart;
 for i:=0 to 3 do
     begin
      VoiceRepart[i xor 3]:=(j and 3) shl 2;
      j:=j shr 2;
     end;
 GVolume:=CDMH.GlobalVolume;
 NumPatt:=CDMH.NumPatterns;
 SNum:=CDMH.NumSamples-1;
 For i:=0 to SNum do
     begin
      BlockRead(WorkFile,Smp,SizeOf(CDMInstrDescr));
      if IOResult>0 then begin Error:=4;GoTo LocExit;end;
      SNo:=Smp.SampleNo;
      Move(Smp.Name,InstrNm[SNo][1],12);
      j:=0;While (j<12) and (InstrNm[SNo][j+1]<>#0) do Inc(j);
      InstrNm[SNo][0]:=Char(j);
      Sizes[SNo]:=Smp.UncompLength;
      LoopStart[SNo]:=Smp.LoopStart;
      LoopEnd[SNo]:=Smp.LoopEnd;
      DefVolm[SNo]:=Smp.DefVolume;
      SpeedOfC[SNo]:=Smp.SpeedOfC;
      InsCompL[SNo]:=Smp.CompLength;
      InsOfs[SNo]:=Smp.SampleOfs;
      if Sizes[SNo]>0
         then InitInstr[SNo]:=True;
     end;
 FillChar(Ordr,SizeOf(Ordr),99);
 BlockRead(WorkFile,Ordr[0],1);
 BlockRead(WorkFile,Ordr[1],Byte(Ordr[0]));
 Move(Ordr[1],Order,128);
 if not InitDecompression then begin Error:=3;FreeAll;GoTo LocExit;end;
 for i:=0 to NumPatt-1 do
     begin
      if @DisplayResults<>NIL then DisplayResults(i+1,255);
      New(Patt[i]);
      if Patt[i]=NIL then begin FreeAll;Error:=3;GoTo LocExit;end;
      BlockRead(WorkFile,j,2);
      DecompressBlock(Patt[i]^,j,1024);
      if IOResult>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
      FlushInputBuffer;
     end;
 InitDecompression;
 for i:=0 to 30 do
     if InitInstr[i] then
        begin
         if @DisplayResults<>NIL then DisplayResults(i,SNum);
         FlushInputBuffer;
         Seek(WorkFile,InsOfs[i]);
         GetMem(InsOrg[i],Sizes[i]+16);
         p:=InsOrg[i];if p=NIL then begin FreeAll;Error:=3;GoTo LocExit; end;
         if Word(p)>0 then asm  inc word ptr [p+2]; mov word ptr p,0 end;
         Instr[i]:=p;
         DecompressBlock(Instr[i]^,InsCompL[i],Sizes[i]);
         if IOResult>0 then begin FreeAll;Error:=4;GoTo LocExit;end;
        end;
LocExit:
 EndProcess;
 Close(WorkFile);
 FileMode:=PrevFM;InOutRes:=0;
end;

(*۲*)
(*       Save a .CDM song      ۲*)
(*۲*)
Procedure SaveCDM;
label LocExit;
var i,SNum,InsO
           : Integer;
    Smp    : CDMInstrDescr;
    Ordr   : String[128];
    FPos,OldPos
           : LongInt;
    InsOrd : array[0..30] of byte;
    j      : Byte;
begin
 Error:=0;InOutRes:=0;
 Assign(WorkFile,FName);Rewrite(WorkFile,1);
 if IOResult>0 then begin Error:=5;GoTo LocExit;end;
 FillChar(SongName[Length(SongName)+1],20-Length(SongName),0);
 Move(SongName[1],CDMHeader.SongName,20);
 CDMHeader.Temp:=RealTemp;
 CDMHeader.GlobalVolume:=GVolume;
 CDMHeader.NumPatterns:=NumPatt;

 j:=0;for i:=0 to 3 do j:=(j shl 2) or (VoiceRepart[i] shr 2);
 CDMHeader.VoiceRepart:=j;

 SNum:=0;For i:=0 to 30 do if InitInstr[i] then Inc(SNum);
 CDMHeader.NumSamples:=SNum;
 BlockWrite(WorkFile,CDMHeader,SizeOf(CDMHeaderType));
 if IOResult>0 then begin Error:=4;GoTo LocExit;end;
 InsO:=0;
 For i:=0 to 30 do
     if InitInstr[i] then
        begin
         FillChar(Smp,SizeOf(Smp),0);
         FillChar(InstrNm[i][Length(InstrNm[i])+1],12-Length(InstrNm[i]),0);
         Move(InstrNm[i][1],Smp.Name,12);
         Smp.UncompLength:=Sizes[i];
         Smp.LoopStart:=LoopStart[i];
         Smp.LoopEnd:=LoopEnd[i];
         Smp.DefVolume:=DefVolm[i];
         Smp.SpeedOfC:=SpeedOfC[i];
         Smp.SampleNo:=i;
         InsOrd[i]:=InsO;Inc(InsO);
         BlockWrite(WorkFile,Smp,SizeOf(CDMInstrDescr));
         if IOResult>0 then begin Error:=4;GoTo LocExit;end;
        end;
 Move(Order,Ordr[1],128);
 i:=0;While Order[i]<99 do Inc(i);Ordr[0]:=Char(i);
 BlockWrite(WorkFile,Ordr,i+1);
 if not InitCompression then begin Error:=3;FreeAll;GoTo LocExit;end;
 for i:=0 to NumPatt-1 do
     begin
      if @DisplayResults<>NIL then DisplayResults(i+1,255);
      OldPos:=FilePos(WorkFile);
      BlockWrite(WorkFile,i,2);
      CompressBlock(Patt[i]^,1024);
      FlushOutBuffer;
      Seek(WorkFile,OldPos);
      BlockWrite(WorkFile,CodeSize,2);
      Seek(WorkFile,FileSize(WorkFile));
      if IOResult>0 then begin Error:=4;GoTo LocExit;end;
     end;
 InitCompression;
 for i:=0 to 30 do
     if InitInstr[i] then
        begin
         if @DisplayResults<>NIL then DisplayResults(i,SNum);
         OldPos:=FilePos(WorkFile);
         CompressBlock(Instr[i]^,Sizes[i]);
         FlushOutBuffer;
         FPos:=FilePos(WorkFile);
         Seek(WorkFile,SizeOf(CDMHeader)+InsOrd[i]*SizeOf(CDMInstrDescr)+26);
         BlockWrite(WorkFile,CodeSize,2);
         BlockWrite(WorkFile,OldPos,4);
         Seek(WorkFile,FPos);
         if IOResult>0 then begin Error:=4;GoTo LocExit;end;
        end;
LocExit:
 EndProcess;
 Close(WorkFile);InOutRes:=0;
end;

begin
 FillChar(InitInstr,31,0);NumPatt:=0;FreeAll;@DisplayResults:=NIL;
end.
